stages:
    - build
    - reports

test_ubuntu:
    # Define the docker image
    image: "ubuntu:18.04"
    stage: build

    # Install the software 
    before_script:
        - apt-get update -yqq
        - apt-get install -yqq gnupg
        - cp .apt/deb-sanitizer-libraries.list /etc/apt/sources.list.d/
        - apt-key add .apt/deb-sanitizer-libraries.pub
        - apt-get update -yqq
        - apt-get install -yqq libglibtsan2.0-0 dpkg libffi-dev libtsan0 llvm-9
        - apt-get install -yqq --no-install-recommends
                  build-essential ninja-build
                  pkg-config libglib2.0-dev
                  python3 python3-setuptools python3-pip python3-wheel
                  clang-tools-9 clang-format-9 clang-tidy-9
                  gcovr lcov valgrind
        - pip3 install scan-build meson
        - export PATH="$PWD/tests:$PATH"
        - export TSAN_OPTIONS="suppressions=/opt/tsan/share/glib-2.0/tsan/glib.supp"


    # Run the build
    script:
        - scripts/test.sh

    coverage: '/^TOTAL.*\s+(\d+\%)$/'

    artifacts:
        when: always
        expose_as: 'Test'
        paths:
            - ci/
        reports:
            cobertura: ci/reports/coverage.xml

build_ubuntu:
    # Define the docker image
    image: "ubuntu:18.04"
    stage: build

    # Install the software 
    before_script:
        - apt-get update -yqq
        - apt-get install -yqq --no-install-recommends 
                  build-essential ninja-build
                  pkg-config libglib2.0-dev
                  python3 python3-setuptools python3-pip python3-wheel
        - pip3 install meson
        - ln -s /usr/bin/clang-9 /usr/bin/clang

    # Run the build
    script:
        - scripts/build_release.sh

    artifacts:
        when: always
        expose_as: 'Release'
        paths:
            - ci/

static_analysis:
    stage: reports
    when: always
    dependencies:
        - test_ubuntu
    script: echo "Static analysis artifacts"
    artifacts:
        when: always
        expose_as: 'Static analysis'
        paths:
            - ci/reports/static_analysis.html

coverage:
    stage: reports
    when: always
    dependencies:
        - test_ubuntu
    script: echo "Coverage artifacts"
    artifacts:
        when: always
        expose_as: 'Coverage'
        paths:
            - ci/reports/coveragereport/
